package org.processmininguc.balsa.dialogs;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.Dimension;

import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmininguc.balsa.models.Artifact;
import org.processmininguc.balsa.models.Balsa;
import org.processmininguc.balsa.parameters.ConvertBalsaArtifactToPetriNetConfiguration;

public class ConvertBalsaArtifactToPetriNetDialog extends JPanel {

	private static final long serialVersionUID = 1673147306048318712L;

	public ConvertBalsaArtifactToPetriNetDialog(UIPluginContext context, Balsa balsa,
			final ConvertBalsaArtifactToPetriNetConfiguration configuration) {
		
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL } };
		setLayout(new TableLayout(size));
		
		final DefaultListModel<Artifact> artifacts = new DefaultListModel<Artifact>();
		for(Artifact artifact: balsa.getArtifacts()){
			artifacts.addElement(artifact);
		}
		
		final ProMList<Artifact> list = new ProMList<Artifact>("Artifacts", artifacts);
		list.setSelection(configuration.getArtifactToConvert());
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				configuration.setArtifactToConvert(list.getSelectedValuesList().get(0));
			}
		});
		
		list.setPreferredSize(new Dimension(100, 100));
		add(list, "0, 0");
	}
}
