// Copyright (C) 2014 by Jorge Munoz-Gama. All rights reserved. 
// Released under the terms of the Lesser GNU General Public License (L-GPL) version 2 or later.

package org.processmininguc.balsa.models;

/**
 * 
 * StateMachineDiagramCondition is implemented by StateMachineDiagramCondImpl. StateMachineDiagramCondImpl 
 * is extended by StateMachineDiagramCondArtImpl
 * 
 * @author Montse
 *
 */
public interface StateMachineDiagramCondition {
	
	/**
	 * Returns true if the condition refers to the number of another artifact related to the current artifact.
	 * @return
	 */
	public boolean referencesArtifactNum();
	
	/**
	 * Returns the string representing the condition.
	 * @return
	 */
	public String getCondition();
	
	public boolean equals(StateMachineDiagramCondition cond);

}
