package org.processmininguc.balsa.models.impl.smadu;

import java.util.List;

import org.processmininguc.balsa.models.ActivityDiagramActivity;
import org.processmininguc.balsa.models.ActivityDiagramArc;
import org.processmininguc.balsa.models.ActivityDiagramElement;
import org.processmininguc.utils.Utils;

import activity.Action;
import activity.Activity;

public class ActivityDiagramActivityImpl extends Action implements ActivityDiagramActivity  {
	
	public ActivityDiagramActivityImpl(){
		super();
	}
	
	public ActivityDiagramActivityImpl(String name){
		super(name);
	}
	
	public ActivityDiagramActivityImpl(String name, Activity act) {
		super(name,act);
	}

	public boolean isActivity() {
		return this.isAction();
	}

	public boolean isFinalNode() {
		return this.isFinal();
	}

	public List<ActivityDiagramArc> getIncomingArcs() {
//		List<ActivityEdge> actEdgeList = getIncomingEdges();
//		List<ActivityDiagramArc> resList = new LinkedList();
//		for(ActivityEdge edge: actEdgeList){
//			resList.add(edge)
//		}
		return Utils.convert(this.getIncomingEdges());
	}

	public List<ActivityDiagramArc> getOutgoingArcs() {
		return Utils.convert(this.getOutgoingEdges());
	}

	public List<ActivityDiagramElement> getPreviousElements() {
		return Utils.convert(this.getPreviousNodes());
	}

	public List<ActivityDiagramElement> getNextElements() {
		return Utils.convert(this.getNextNodes());
	}

}