package org.processmininguc.balsa.models.impl.smadu;

import java.util.LinkedList;
import java.util.List;

import org.processmininguc.balsa.models.ActivityDiagramArc;
import org.processmininguc.balsa.models.ActivityDiagramElement;
import org.processmininguc.balsa.models.ActivityDiagramFinalNode;
import org.processmininguc.utils.Utils;

import activity.ActivityFinalNode;

public class ActivityDiagramFinalNodeImpl extends ActivityFinalNode implements ActivityDiagramFinalNode {

	public boolean isActivity() {
		return this.isAction();
	}

	public boolean isFinalNode() {
		return this.isFinal();
	}
	
	public List<ActivityDiagramArc> getIncomingArcs() {
		return Utils.convert(this.getIncomingEdges());
	}

	public List<ActivityDiagramArc> getOutgoingArcs() {
//		List<ActivityEdge> edgeList = this.getOutgoingEdges();
//		List<ActivityDiagramArc> arcList = new LinkedList<ActivityDiagramArc>();
//		for(ActivityEdge edge: edgeList){
//			arcList.add((ActivityDiagramArc)edge);
//		}
		return Utils.convert(this.getOutgoingEdges());
	}

	public List<ActivityDiagramElement> getPreviousElements() {
//		List<ActivityNode> actNodeList = this.getPreviousNodes();
//		List<ActivityDiagramElement> actElementList = new LinkedList<ActivityDiagramElement>();
//		for(ActivityNode actNode: actNodeList){
//			actElementList.add((ActivityDiagramElement)actNode);
//		}
		return Utils.convert(this.getPreviousNodes());
	}

	public List<ActivityDiagramElement> getNextElements() {
//		List<ActivityNode> actNodeList = this.getNextNodes();
//		List<ActivityDiagramElement> actElementList = new LinkedList<ActivityDiagramElement>();
//		for(ActivityNode actNode: actNodeList){
//			actElementList.add((ActivityDiagramElement)actNode);
//		}
		//TODO: Sort this out. Problem seems to be that Final Node returns null list when asking for next elements.
		if (! (this.getNextNodes() == null)){
			return Utils.convert(this.getNextNodes());
		}
		else{
			return new LinkedList<>();
		}
	}

}
