package org.processmininguc.balsa.models.impl.smadu;

import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import org.processmininguc.balsa.models.ActivityDiagram;
import org.processmininguc.balsa.models.ActivityDiagramActivity;
import org.processmininguc.balsa.models.ActivityDiagramInitialNode;
import org.processmininguc.balsa.models.structures.OpType;
import org.processmininguc.balsa.models.structures.SimpleADChange;
import org.processmininguc.utils.Utils;

import activity.Action;
import activity.Activity;
import activity.InitialNode;
import stateMachine.Transition.EventDepCondType;

public class ActivityDiagramImpl extends Activity implements ActivityDiagram {
	
	private List<SimpleADChange> m_changes;
	
	protected ActivityDiagramImpl(){
		super();
		m_changes = new LinkedList<>();
	}
	
	protected ActivityDiagramImpl(String name){
		super(name);
		m_changes = new LinkedList<>();
	}
	
	protected ActivityDiagramImpl(String name, ActivityDiagramInitialNodeImpl node){
		super(name, node);
		m_changes = new LinkedList<>();
	}

	protected ActivityDiagramImpl(String name, InitialNode iniNode) {
		super(name,iniNode);
		m_changes = new LinkedList<>();
	}

	protected ActivityDiagramImpl(String name, InitialNode iniNode, generic.Note note) {
		super(name, iniNode, note);
		m_changes = new LinkedList<>();	
	}

	protected ActivityDiagramImpl(String name, InitialNode iniNode, List<generic.Note> noteList) {
		super(name,iniNode,noteList);
		m_changes = new LinkedList<>();
	}

	public List<ActivityDiagramActivity> getActivities() {
		Set<Action> actionList = this.getActions();
		LinkedList<ActivityDiagramActivity> adActList = new LinkedList<ActivityDiagramActivity>();
		for(Action a: actionList){
			adActList.add((ActivityDiagramActivityImpl)a);
		}
		return adActList;
	}

	public ActivityDiagramInitialNode getInitialNode() {
		return (ActivityDiagramInitialNode)this.getIniNode();
	}

	public List<org.processmininguc.balsa.models.Annotation> getNotes() {
		List<generic.Note> res = this.getNoteList(); 
		List<org.processmininguc.balsa.models.Annotation> retList;
		//List<org.processmininguc.balsa.models.Annotation> retList = new LinkedList<org.processmininguc.balsa.models.Annotation>();
		retList = Utils.convert(res);
		return retList;
	}
	
	public void createChangeAddToList(String contextArtifact, String targetArtifact, OpType op, int number, EventDepCondType evDepCond){
		SimpleADChange simpleCh = new SimpleADChange(contextArtifact, targetArtifact, op, number, evDepCond);
		m_changes.add(simpleCh);
	}

	public List<SimpleADChange> getSimpleChanges() {
		return m_changes;
	}
	


}
