package org.processmininguc.balsa.models.impl.smadu;

import java.util.List;

import org.processmininguc.balsa.models.ActivityDiagramArc;
import org.processmininguc.balsa.models.ActivityDiagramElement;
import org.processmininguc.balsa.models.ActivityDiagramInitialNode;
import org.processmininguc.utils.Utils;

import activity.ControlFlow;
import activity.InitialNode;

public class ActivityDiagramInitialNodeImpl extends InitialNode implements ActivityDiagramInitialNode {

	public ActivityDiagramInitialNodeImpl() {
		super();
	}
	
	protected ActivityDiagramInitialNodeImpl(ControlFlow outgoing) {
		super(outgoing);
	}

	public ActivityDiagramInitialNodeImpl(List<ControlFlow> outgoing) {
		super(outgoing);
	}

	public boolean isActivity() {
		return isAction();
	}

	public boolean isFinalNode() {
		return isFinal();
	}

	public List<ActivityDiagramArc> getIncomingArcs() {
		return Utils.convert(this.getIncomingEdges());
	}

	public List<ActivityDiagramArc> getOutgoingArcs() {
		return Utils.convert(this.getOutgoingEdges());
	}

	public List<ActivityDiagramElement> getPreviousElements() {
		return Utils.convert(this.getPreviousNodes());
	}

	public List<ActivityDiagramElement> getNextElements() {
		return Utils.convert(this.getNextNodes());
	}

}
