package org.processmininguc.balsa.models.impl.smadu;

import java.util.List;

import org.processmininguc.balsa.models.StateMachineDiagramState;
import org.processmininguc.balsa.models.StateMachineDiagramTransition;
import org.processmininguc.utils.Utils;

import stateMachine.State;
import stateMachine.Transition;
import stateMachine.Vertex;

public class StateMachineDiagramRealStateImpl extends State implements StateMachineDiagramStateInt {

	public StateMachineDiagramRealStateImpl(String name) {
		super(name);
	}

	public List<StateMachineDiagramTransition> getIncomingTransition() {
		List<Transition> transList = this.getIncoming();
		List<StateMachineDiagramTransition> smdTransList = Utils.convert(transList);
		return smdTransList;
	}

	public List<StateMachineDiagramTransition> getOutgoingTransition() {
		List<Transition> transList = this.getOutgoing();
		List<StateMachineDiagramTransition> smdTransList = Utils.convert(transList);
		return smdTransList;
	}

	public List<StateMachineDiagramState> getNextStates() {
		List<Vertex> vertexList = this.getNextVertices();
		List<StateMachineDiagramState> smdStates = Utils.convert(vertexList);
		return smdStates;
	}

	public List<StateMachineDiagramState> getPreviousStates() {
		List<Vertex> vertexList = this.getPreviousVertices();
		List<StateMachineDiagramState> smdStates = Utils.convert(vertexList);
		return smdStates;
	}

}
