package org.processmininguc.parser;

import org.processmininguc.balsa.models.structures.OpType;
import org.processmininguc.balsa.models.structures.RestrictionType;

import stateMachine.Transition.EventDepCondType;

public class ParsedAnnotation {
	
	private String m_context;
	private String m_targetArtifact;
	private OpType m_opType;
	private EventDepCondType m_evDepCond;
	private int m_number;
	private RestrictionType m_restrictionType;
	
	public ParsedAnnotation(String context, String targetArtifact, OpType opType, EventDepCondType evDepCond, int number, RestrictionType resType){
		m_context = context;
		m_targetArtifact = targetArtifact;
		m_opType = opType;
		m_evDepCond = evDepCond;
		m_number = number;
		m_restrictionType = resType;
	}
	
	public String getContext(){
		return m_context;
	}
	
	public String getTargetArtifact(){
		return m_targetArtifact;
	}

	public OpType getOpType(){
		return m_opType;
	}
	
	public EventDepCondType getEventDepCondType(){
		return m_evDepCond;
	}
	
	public int getNumber(){
		return m_number;
	}
	
	public RestrictionType getRestrictionType(){
		return m_restrictionType;
	}
}
