package tests;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.LinkedList;
import java.util.List;

import org.processmininguc.balsa.algorithms.BalsaArtifactToPetriNetConverter;
import org.processmininguc.balsa.models.ActivityDiagram;
import org.processmininguc.balsa.models.Balsa;
import org.processmininguc.balsa.models.StateMachineDiagram;
import org.processmininguc.balsa.models.impl.smadu.ActivityDiagramFactory;
import org.processmininguc.balsa.models.impl.smadu.ActivityDiagramImpl;
import org.processmininguc.balsa.models.impl.smadu.AnnotationFactory;
import org.processmininguc.balsa.models.impl.smadu.BalsaFactorySMADU;
import org.processmininguc.balsa.models.impl.smadu.StateMachineDiagramFactory;
import org.processmininguc.balsa.models.impl.smadu.StateMachineDiagramImpl;
import org.processmininguc.balsa.parameters.ConvertBalsaArtifactToPetriNetConfiguration;
import org.processmininguc.utils.Utils;

import activity.Activity;
import creator.Printer;
import parser.ParserError;
import parser.ParserErrorType;
import parser.ParserFacade;
import stateMachine.StateMachine;

public class AlgorithmTest {

	public static void main(String[] args) throws Exception {
		
		//TODO: Aixo es un test senzill i hardcoded dels algorismes
		
		//String inputFile = "V:\\Dropbox\\PHD\\37-Tool\\argoUML\\prova-2estereotips-profile.xmi";
		String inputFile = "C:\\Users\\Montse\\Dropbox\\PHD\\44-Bicing\\XML-exports\\project.xml";
		//String outputPath = "V:\\Dropbox\\PHD\\37-Tool\\proves\\result3";
		File file = new File(inputFile);
		
		InputStream is = new FileInputStream("C:\\Users\\Montse\\Dropbox\\PHD\\44-Bicing\\XML-exports\\project.xml");
		//InputStream is = new FileInputStream("V:\\Dropbox\\PHD\\53-visual_paradigm_diagrams\\exports\\project.xml");
		//InputStream is = new FileInputStream("V:\\Dropbox\\PHD\\53-visual_paradigm_diagrams\\exports\\simple-ad-dec-node-smd\\project.xml");
		
		BalsaFactorySMADU balsaFactory = new BalsaFactorySMADU();
		StateMachineDiagramFactory smdFactory = new StateMachineDiagramFactory();
		ActivityDiagramFactory adFactory = new ActivityDiagramFactory();
		AnnotationFactory annotFactory = new AnnotationFactory();
		
		List<StateMachine> smdList = new LinkedList<StateMachine>();
		List<Activity> adList = new LinkedList<Activity>();
		
		File tempFile = File.createTempFile("tempFile",".tmp");
        OutputStream outStream = new FileOutputStream(tempFile);
        byte[] buffer = new byte[is.available()];
        is.read(buffer);
        outStream.write(buffer);
        outStream.flush();
        outStream.close();
        is.close();
        
		ParserError peSMD = ParserFacade.parseStateMachines(tempFile, smdList, smdFactory);
		if (!peSMD.getErrorType().equals(ParserErrorType.SUCCESS)){
			//TODO: Improve this
			System.err.println("Error SMDs");
		}
		for(StateMachine smd: smdList){
			Printer.printStateMachineDiagram(smd);
		}
		ParserError peAD = ParserFacade.parseActivityDiagrams(tempFile, adList, adFactory, annotFactory);
		if(!peAD.getErrorType().equals(ParserErrorType.SUCCESS)){
			//TODO: Improve this
			System.err.println("Error ADs");
		}
		
		List<ActivityDiagramImpl> adListSMADU = Utils.convert(adList);
		List<StateMachineDiagramImpl> smdListSMADU = Utils.convert(smdList);
		
		List<StateMachineDiagram> smdListI = Utils.convert(smdListSMADU);
		List<ActivityDiagram> adListI = Utils.convert(adListSMADU);
		
		Balsa balsa = balsaFactory.createBalsa(smdListI, adListI);

		ConvertBalsaArtifactToPetriNetConfiguration configuration = new ConvertBalsaArtifactToPetriNetConfiguration(balsa);
		
		BalsaArtifactToPetriNetConverter balsaPNConverter = new BalsaArtifactToPetriNetConverter(balsa, configuration);
		

	}

}
